/*******************************************************************************
 * Copyright (c) 2010-2018, Zoltan Ujhelyi, Istvan Rath and Daniel Varro
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-v20.html.
 * 
 * SPDX-License-Identifier: EPL-2.0
 *
 * This file was generated from EMFPatternLanguage.xtext
 *******************************************************************************/
package org.eclipse.viatra.query.tooling.generator.model.ui.contentassist.antlr;

import java.util.Collection;
import java.util.Map;
import java.util.HashMap;

import org.antlr.runtime.RecognitionException;
import org.eclipse.xtext.AbstractElement;
import org.eclipse.xtext.ui.editor.contentassist.antlr.AbstractContentAssistParser;
import org.eclipse.xtext.ui.editor.contentassist.antlr.FollowElement;
import org.eclipse.xtext.ui.editor.contentassist.antlr.internal.AbstractInternalContentAssistParser;

import com.google.inject.Inject;

import org.eclipse.viatra.query.tooling.generator.model.services.GeneratorModelGrammarAccess;

public class GeneratorModelParser extends AbstractContentAssistParser {
	
	@Inject
	private GeneratorModelGrammarAccess grammarAccess;
	
	private Map<AbstractElement, String> nameMappings;
	
	@Override
	protected org.eclipse.viatra.query.tooling.generator.model.ui.contentassist.antlr.internal.InternalGeneratorModelParser createParser() {
		org.eclipse.viatra.query.tooling.generator.model.ui.contentassist.antlr.internal.InternalGeneratorModelParser result = new org.eclipse.viatra.query.tooling.generator.model.ui.contentassist.antlr.internal.InternalGeneratorModelParser(null);
		result.setGrammarAccess(grammarAccess);
		return result;
	}
	
	@Override
	protected String getRuleName(AbstractElement element) {
		if (nameMappings == null) {
			nameMappings = new HashMap<AbstractElement, String>() {
				private static final long serialVersionUID = 1L;
				{
					put(grammarAccess.getViatraQueryGeneratorModelAccess().getGroup(), "rule__ViatraQueryGeneratorModel__Group__0");
					put(grammarAccess.getGeneratorModelReferenceAccess().getGroup(), "rule__GeneratorModelReference__Group__0");
					put(grammarAccess.getConfigurationAccess().getGroup(), "rule__Configuration__Group__0");
					put(grammarAccess.getConfigurationAccess().getGroup_1(), "rule__Configuration__Group_1__0");
					put(grammarAccess.getPropertyAccess().getGroup(), "rule__Property__Group__0");
					put(grammarAccess.getViatraQueryGeneratorModelAccess().getGenmodelsAssignment_0(), "rule__ViatraQueryGeneratorModel__GenmodelsAssignment_0");
					put(grammarAccess.getViatraQueryGeneratorModelAccess().getConfigurationAssignment_1(), "rule__ViatraQueryGeneratorModel__ConfigurationAssignment_1");
					put(grammarAccess.getGeneratorModelReferenceAccess().getGenmodelAssignment_1(), "rule__GeneratorModelReference__GenmodelAssignment_1");
					put(grammarAccess.getConfigurationAccess().getNameAssignment_0(), "rule__Configuration__NameAssignment_0");
					put(grammarAccess.getConfigurationAccess().getPropertyAssignment_1_1(), "rule__Configuration__PropertyAssignment_1_1");
					put(grammarAccess.getPropertyAccess().getKeyAssignment_0(), "rule__Property__KeyAssignment_0");
					put(grammarAccess.getPropertyAccess().getValueAssignment_2(), "rule__Property__ValueAssignment_2");
				}
			};
		}
		return nameMappings.get(element);
	}
	
	@Override
	protected Collection<FollowElement> getFollowElements(AbstractInternalContentAssistParser parser) {
		try {
			org.eclipse.viatra.query.tooling.generator.model.ui.contentassist.antlr.internal.InternalGeneratorModelParser typedParser = (org.eclipse.viatra.query.tooling.generator.model.ui.contentassist.antlr.internal.InternalGeneratorModelParser) parser;
			typedParser.entryRuleViatraQueryGeneratorModel();
			return typedParser.getFollowElements();
		} catch(RecognitionException ex) {
			throw new RuntimeException(ex);
		}		
	}
	
	@Override
	protected String[] getInitialHiddenTokens() {
		return new String[] { "RULE_WS", "RULE_ML_COMMENT", "RULE_SL_COMMENT" };
	}
	
	public GeneratorModelGrammarAccess getGrammarAccess() {
		return this.grammarAccess;
	}
	
	public void setGrammarAccess(GeneratorModelGrammarAccess grammarAccess) {
		this.grammarAccess = grammarAccess;
	}
}
